//@author: antokhio
//@help: template for standard shaders
//@tags: template
//@credits: 

//StructuredBuffer<float4> color <bool color=true;>;

Texture2D tex0;
SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};

Texture2D tex1;
SamplerState s1:IMMUTABLE {Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};

float4x4 tW : WORLD;
float4x4 tVP : VIEWPROJECTION;

float4x4 tSlice;

float Alpha <float uimin=0.0; float uimax=1.0;> = 1; 
float4 cAmb0 <bool color=true; String uiname="Color0";> = { 1.0f,1.0f,1.0f,1.0f };
float4 cAmb1 <bool color=true; String uiname="Color1";> = { 1.0f,1.0f,1.0f,1.0f };
float4x4 tTex <bool uvspace=true; string uiname="Texture Transform";>;
float4x4 tColor <string uiname="Color Transform";>;

struct VS_IN
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;
};

struct VS_OUT
{
    float4 pos: SV_POSITION;
	float4 posW : POSITION;
    float4 uv: TEXCOORD0;
};

bool SliceInside(float4 p,float4x4 st){
	p=mul(p,st);
	return all(abs(p.xyz)<.5);
}

VS_OUT VS(VS_IN input)
{
    VS_OUT output = (VS_OUT)0;
    output.pos  = mul(input.pos,mul(tW,tVP));
	output.posW = mul(input.pos, tW);
    output.uv = mul(input.uv, tTex);
    return output;
}

float4 PS(VS_OUT input): SV_Target
{
    float4 col = tex0.Sample(s0,input.uv.xy) * cAmb0;
	
	if(!SliceInside(input.posW,tSlice))col = tex1.Sample(s1,input.uv.xy) * cAmb1;;
	
	col.a *= Alpha;
    return col;
}

technique10 Template
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




